//
//      
// 

//  
#include <stdlib.h>
#include "array.h"


//            
//
double * ReadArrayCnt(FILE *f, size_t *size, int *errcode)
{
    size_t i;    // 
    double x;    //    
    double *a;   //   

    *errcode = 0;  // ,    

    //     !
    if (!f) {
       *size = 0;
       *errcode = -1; // file is not opened 
       return 0;
    }

    //   
    for (i=0; fscanf(f,"%lf",&x)==1; i++);
    *size = i;
    if (*size == 0) { //    
       *errcode = -2; // no numbers in file 
       return 0;
    }

    //  
    a = (double*)malloc(*size*sizeof(double));
    if (!a) {
       *errcode = -3; // memory allocation error 
        return 0;
    }

    //      

    rewind(f);
  
    for (i=0; i<*size && fscanf(f,"%lf", &a[i])==1; i++);
    if (i != *size) { //    !
       *errcode = -4; // rereading error 
       free(a);
       return 0;
    } 

    return a;
}


//       ,       
//
double * ReadArrayNum(FILE *f, size_t *size, int *errcode)    
{
    size_t i;    // 
    double *a;   //   

    *errcode = 0;  // ,    

    //     !
    if (!f) {
       *size = 0;
       *errcode = -1; // file is not opened 
       return 0;
    }

    //   
    if ( fscanf(f,"%llu", size) != 1) {
       *size = 0;
       *errcode = -2;  // cannot read array length  
       return 0;
    }

    //  
    a = (double*)malloc(*size*sizeof(double));
    if (!a) {
       *errcode = -3; // memory allocation error 
        return 0;
    }

    //  
    for (i=0; i<*size && fscanf(f,"%lf", &a[i])==1; i++);

    *size = i;  //   

    return a;
}

//           
// 
double * GenerateArray(size_t size)
{
    size_t i;
    double *a;
    a = (double*)malloc(size*sizeof(double));
    if (!a) {
        return 0;
    }
    for (i = 0; i < size; i++) {
        a[i] = (double)(rand()%1000); //   0  999
    }
    return a;
}

//       
//
void PrintArray(FILE *f, double *a, size_t size, const char *text)
{
    size_t i; 
    int rowN = 5;
    if (text) { fprintf(f, "%s", text); } 
    for (i = 0; i < size; i++) {
        fprintf(f,"%s%15.10f", (i%rowN == 0) ? "\n":"  ", a[i]);
    }
    fprintf(f, "\n");
}

//     
//  
//double SetArray(double *a, size_t size, double value)
//{
//   do it yourself
//}



